Subject: Re: bug#51468: reftex-ref-style-alist in amsmath.el

From: Gustavo Barros <[email-masked]>
Date: Fri, 29 Oct 2021 07:28:47 -0300

Hi Arash,

On Fri, 29 Oct 2021 at 11:31, Arash Esbati <[email-masked]> wrote:

> My understanding of `reftex-ref-style-alist' being a custom variable 
> is
> that you can toggle the keys for the reference macros if you want to.
> The reference styles get activated:
>
> a) in RefTeX without AUCTeX: If you add an entry to
>    `reftex-ref-style-default-list'
>    
>    ,----[ C-h v reftex-ref-style-default-list RET ]
>    | reftex-ref-style-default-list is a variable defined in 
>    ‘reftex-vars.el’.
>    | 
>    | Its value is ("Default")
>    | 
>    | List of reference styles to be activated by default.
>    | The order is significant and controls the order in which macros
>    | can be cycled in the buffer for selecting a label.  The entries
>    | in the list have to match the respective reference style names
>    | used in the variable ‘reftex-ref-style-alist’.
>    `----
>
> b) in AUCTeX: When you have set `LaTeX-reftex-ref-style-auto-activate'
>    to t.
>
> So deleting an entry in `reftex-ref-style-alist' isn't intended to
> prevent a reference style from being activated.

Understood.  I was aware of `reftex-ref-style-default-list', but the 
only way to keep the ref styles responsive to the loaded packages is the 
AUCTeX way, leaving `LaTeX-reftex-ref-style-auto-activate' to t.

> Re-adding the entry is due to supporting older Emacs'en.  The entry 
> for
> "AMSmath" was not present as the variable was introduced[1].  That 
> entry
> was added in 2018 and amsmath.el tries to fill the gap.

That's a good point, I hadn't thought of it.  And explains the 
difference to "Varioref", "Cleveref", "Hyperref" etc. too.

> I think the bottom line is set `LaTeX-reftex-ref-style-auto-activate' 
> to
> nil if you don't want AUCTeX to activate that reference style.
>
> ,----[ C-h v LaTeX-reftex-ref-style-auto-activate RET ]
> | LaTeX-reftex-ref-style-auto-activate is a variable defined in 
> ‘tex-style.el’.
> | 
> | Its value is t
> | 
> | Whether to activate automatically RefTeX reference styles.
> `----

Well, I do like what `LaTeX-reftex-ref-style-auto-activate' does for me, 
I just don't use `\eqref' enough to grant it an entry there.  But, no 
worries, it is easy to keep an `("AMSmath" "amsmath" nil)' in 
`reftex-ref-style-alist' just as well.

Thanks for considering and for the thoughtful answer.

Best,
Gustavo.